#
# spec file for package itrace (Version 0.9)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash binutils binutils-devel bzip2 coreutils cpio cpp cpp42 cracklib cvs diffutils file filesystem fillup findutils gawk gcc gcc42 gdbm gettext gettext-devel glibc glibc-devel glibc-locale grep groff gzip info insserv kernel-source kernel-syms less libacl libattr libbz2-1 libbz2-devel libdb-4_5 libgcc42 libgomp42 libltdl-3 libmudflap42 libreadline5 libstdc++42 libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses net-tools netcfg pam pam-modules patch perl perl-base permissions popt rpm sed sysvinit tar texinfo timezone util-linux zlib


Name:           itrace
Version:        0.9
Release:        98.1
BuildRequires:  binutils-devel kernel-source kernel-syms module-init-tools
Url:            http://perfinsp.sourceforge.net/itrace_ppc.html
Summary:        Instruction Tracing Tool
License:        GPL v2 or later
Group:          Development/Tools/Debuggers
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source0:        itrace_ppc64-%{version}.tar.bz2
Patch0:         itrace-0.9.KMP.patch
Patch1:         itrace-0.9.modprobe.patch
Patch2:         itrace-0.9.m32.patch
Patch3:         itrace-dotsym.patch
Patch4:         itrace-post-main.patch
Patch6:         itrace-is_stepping_safe_ss.patch
Patch7:         itrace.warnings.patch
Patch8:         itrace.README.patch
Patch9:         itrace.pi_load.module.patch
Patch10:        itrace.post.strcpy.patch
Patch11:        itrace.config_h.patch
Patch12:        itrace.find_type_devices.patch
Patch13:        itrace.threads-h.patch
ExclusiveArch:  ppc ppc64
Requires:       itrace-kmp-ppc64
%suse_kernel_module_package kdump um xen xenpae default smp debug bigsmp iseries64

%description
ITrace is a software tracing mechanism that runs on Linux. ITrace
traces through application and kernel code and can produce
human-readable ASCII output or qtrace output suitable for analysis by
packages, such as the IBM Performance Simulator for Linux on POWER
(simppc).



Authors:
--------
    Jimmy DeWitt
    Enio Pineda 
    Bob Urquhart
    Scott T. Jones
    Frank Levine
    Craig Chaney
    John Kacur

%debug_package
%package KMP
Summary:        Instruction Tracing Tool
License:        GPL v2 or later
Group:          Development/Tools/Debuggers

%description KMP
ITrace is a software tracing mechanism that runs on Linux. ITrace
traces through application and kernel code and can produce
human-readable ASCII output or qtrace output suitable for analysis by
packages, such as the IBM Performance Simulator for Linux on POWER
(simppc).



Authors:
--------
    Jimmy DeWitt
    Enio Pineda 
    Bob Urquhart
    Scott T. Jones
    Frank Levine
    Craig Chaney
    John Kacur

%prep
%setup -q -n %{name}_ppc64-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%build
autoreconf -i --force
export CFLAGS="$RPM_OPT_FLAGS"
%ifarch ppc
export HOSTTYPE=ppc64
%else
export HOSTTYPE=%{_arch}
%endif
./configure --prefix=%{_prefix} \
            --mandir=%{_mandir} \
            --libdir=%{_libdir} \
            --enable-itrace 
make %{?jobs:-j%jobs}
# build kernel modules
mkdir obj     
for flavor in %flavors_to_build; do
	rm -rf obj/$flavor
	cp -r src/driver obj/$flavor
	make -k V=1 -C /usr/src/linux-obj/%_target_cpu/$flavor M=$PWD/obj/$flavor modules %{?jobs:-j%jobs}
done

%install
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
# install kernel modules
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
	make V=1 TOUT=`pwd`/TOUT -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
	M=$PWD/obj/$flavor
done

%clean
rm -rf $RPM_BUILD_ROOT;

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files 
%defattr(-,root,root)
%doc TODO README
%{_prefix}/bin/*
%{_prefix}/%{_lib}/lib*.a
%{_prefix}/%{_lib}/lib*.la
%{_prefix}/%{_lib}/lib*.so*
%{_prefix}/include/*
%{_mandir}/*/*

%changelog
* Mon Aug 06 2007 - olh@suse.de
- remove inclusion of linux/threads.h
* Thu Jul 05 2007 - olh@suse.de
- replace find_type_devices with of_find_node_by_type
  run ldconfig in post/postun
* Sun Apr 15 2007 - olh@suse.de
- add module-init-tools to buildrequires
* Fri Jan 26 2007 - olh@suse.de
- add binutils-devel to buildrequires
- linux/config.h is gone in 2.6.20
* Tue Oct 17 2006 - olh@suse.de
- fix buffer overflow in post (212916)
* Tue Oct 17 2006 - olh@suse.de
- fix swtrace typo in README
  make modprobe errors non-fatal in pi_load.sh
* Fri Sep 08 2006 - olh@suse.de
- fix build warnings
* Wed Aug 16 2006 - olh@suse.de
- enable is_stepping_safe_ss r13 exception hack for all kernels
* Fri Aug 11 2006 - olh@suse.de
- disable last change, kprobes are fixed in the kernel
* Wed Jun 14 2006 - olh@suse.de
- allow itrace only on POWER5 for the time being (171699 - LTC23555)
  correct setting of pvr in driver_info.cpu_model in pitrace_cpu_init
* Fri Jun 09 2006 - olh@suse.de
- remove the buildrequires for glibc-devel-32bit on ppc64 (177064 - LTC23995)
  It was a temporary workaround for abuild breakage.
* Thu May 04 2006 - olh@suse.de
- fix wrong use of %%p (172541 - LTC23597)
* Thu Apr 20 2006 - olh@suse.de
- handle symbol changes in ELF64 (166171 - LTC23205)
* Tue Apr 11 2006 - olh@suse.de
- remove hardcoded -m32 from CFLAGS
* Tue Mar 28 2006 - olh@suse.de
- add Requires: itrace-kmp-ppc64, pseries is the only supported kernel
* Wed Mar 22 2006 - olh@suse.de
- use modprobe to load the kernel module (153529 - LTC21991)
* Mon Mar 20 2006 - olh@suse.de
- update to version 0.9
* Wed Mar 01 2006 - olh@suse.de
- turn km_itrace into a KMP
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Oct 22 2005 - od@suse.de
- fixed building with debuginfo switched on: changed %%files
  section
* Wed Oct 05 2005 - od@suse.de
- removed superfluous "%%x" in printf in src/mpost/main.c:1564 for
  autobuild
* Fri Jun 24 2005 - od@suse.de
- for ppc, set HOSTTYPE variable to ppc64 (LTC16341 - SUSE87292)
* Mon Jun 13 2005 - od@suse.de
- update to version 0.8:
  - add perfutil.h                (LTC16343 - SUSE87261)
- set HOSTTYPE variable to %%_arch (LTC16341 - SUSE87292)
* Mon May 23 2005 - od@suse.de
- update to version 0.7 (LTC14260 - SUSE67200)
* Wed May 11 2005 - od@suse.de
- fixed return values in swtrace.c and perfutil.c to pass compile
  checks
* Wed May 11 2005 - od@suse.de
- new package
